import numpy as np
import matplotlib.pyplot as plt
import glob
import shelve
from findMaxGapTime import *
from parseRiseSetTimeFile import *

filename='shelve_2d.out'
my_shelf = shelve.open(filename)
for key in my_shelf:
    globals()[key]=my_shelf[key]
my_shelf.close()

# FLAGS
MGT = False
PPD = False
MPT = True

E_CON = ConstantsStruct()
# One Parameter Analysis
i_base = 87.0
alt_base = 400.0
el_base = 5.0
lat_base = 50.0*np.ones((1,1))

plt.figure(1)
el = np.linspace(0,25,51)
lat = np.linspace(0.0,90.0,181)
#plt.plot(lat,mgt_f_of_el_lat[0,:]/3600,'C0',label='0$\degree$')
plt.plot(lat[val_ar_f_of_el_lat[0,:]==1],mgt_f_of_el_lat[0,val_ar_f_of_el_lat[0,:] ==1]/3600,label='0$\degree$')
#plt.plot(lat,mgt_f_of_el_lat[10,:]/3600,'C1',label='5$\degree$')
plt.plot(lat[val_ar_f_of_el_lat[10,:]==1],mgt_f_of_el_lat[10,val_ar_f_of_el_lat[10,:] ==1]/3600,label='10$\degree$')
#plt.plot(lat,mgt_f_of_el_lat[20,:]/3600,'C2',label='10$\degree$')
plt.plot(lat[val_ar_f_of_el_lat[20,:]==1],mgt_f_of_el_lat[20,val_ar_f_of_el_lat[20,:] ==1]/3600,label='20$\degree$')
#plt.plot(lat,mgt_f_of_el_lat[30,:]/3600,'C4',label='15$\degree$')
plt.plot(lat[val_ar_f_of_el_lat[30,:]==1],mgt_f_of_el_lat[30,val_ar_f_of_el_lat[30,:] ==1]/3600,label='30$\degree$')
#plt.plot(lat,mgt_f_of_el_lat[40,:]/3600,'C5',label='20$\degree$')
plt.plot(lat[val_ar_f_of_el_lat[40,:]==1],mgt_f_of_el_lat[40,val_ar_f_of_el_lat[40,:] ==1]/3600,label='40$\degree$')
#plt.plot(lat,mgt_f_of_el_lat[50,:]/3600,'C6',label='25$\degree$')
plt.plot(lat[val_ar_f_of_el_lat[50,:]==1],mgt_f_of_el_lat[50,val_ar_f_of_el_lat[50,:] ==1]/3600,label='50$\degree$')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Maximum Gap Time (hr)')
plt.legend(title='Minimum Elevation Angle',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.figure(2)
el = np.linspace(0,25,51)
lat = np.linspace(0.0,90.0,181)
plt.plot(lat,ppd_f_of_el_lat[0,:],label='0$\degree$')
plt.plot(lat,ppd_f_of_el_lat[10,:],label='5$\degree$')
plt.plot(lat,ppd_f_of_el_lat[20,:],label='10$\degree$')
plt.plot(lat,ppd_f_of_el_lat[30,:],label='15$\degree$')
plt.plot(lat,ppd_f_of_el_lat[40,:],label='20$\degree$')
plt.plot(lat,ppd_f_of_el_lat[50,:],label='25$\degree$')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Passes Per Day')
plt.legend(title='Minimum Elevation Angle',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.figure(3)
el = np.linspace(0,25,51)
lat = np.linspace(0.0,90.0,181)
plt.plot(lat,mpt_f_of_el_lat[0,:]/60,label='0$\degree$')
plt.plot(lat,mpt_f_of_el_lat[10,:]/60,label='5$\degree$')
plt.plot(lat,mpt_f_of_el_lat[20,:]/60,label='10$\degree$')
plt.plot(lat,mpt_f_of_el_lat[30,:]/60,label='15$\degree$')
plt.plot(lat,mpt_f_of_el_lat[40,:]/60,label='20$\degree$')
plt.plot(lat,mpt_f_of_el_lat[50,:]/60,label='25$\degree$')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Mean Pass Time (min)')
plt.legend(title='Minimum Elevation Angle',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.figure(4)
el = np.linspace(0,25,51)
lat = np.linspace(0.0,90.0,181)
plt.plot(lat,np.multiply(mpt_f_of_el_lat[0,:], ppd_f_of_el_lat[0,:])/60 ,label='0$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_el_lat[10,:],ppd_f_of_el_lat[10,:])/60,label='5$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_el_lat[20,:],ppd_f_of_el_lat[20,:])/60,label='10$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_el_lat[30,:],ppd_f_of_el_lat[30,:])/60,label='15$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_el_lat[40,:],ppd_f_of_el_lat[40,:])/60,label='20$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_el_lat[50,:],ppd_f_of_el_lat[50,:])/60,label='25$\degree$')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Mean Daily Coverage Time (min)')
plt.legend(title='Minimum Elevation Angle',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.show()

plt.figure(5)
inc = np.linspace(0,180,361)
lat = np.linspace(0.0,90.0,181)
#plt.plot(lat,mgt_f_of_inc_lat[20,:]/3600,label='10$\degree$')
plt.plot(lat[val_ar_f_of_inc_lat[20,:]==1],mgt_f_of_inc_lat[20,val_ar_f_of_inc_lat[20,:] ==1]/3600,label='10$\degree$')
#plt.plot(lat,mgt_f_of_inc_lat[50,:]/3600,label='25$\degree$')
plt.plot(lat[val_ar_f_of_inc_lat[50,:]==1],mgt_f_of_inc_lat[50,val_ar_f_of_inc_lat[50,:] ==1]/3600,label='25$\degree$')
#plt.plot(lat,mgt_f_of_inc_lat[80,:]/3600,label='40$\degree$')
plt.plot(lat[val_ar_f_of_inc_lat[80,:]==1],mgt_f_of_inc_lat[80,val_ar_f_of_inc_lat[80,:] ==1]/3600,label='40$\degree$')
#plt.plot(lat,mgt_f_of_inc_lat[110,:]/3600,label='55$\degree$')
plt.plot(lat[val_ar_f_of_inc_lat[110,:]==1],mgt_f_of_inc_lat[110,val_ar_f_of_inc_lat[110,:] ==1]/3600,label='55$\degree$')
#plt.plot(lat,mgt_f_of_inc_lat[140,:]/3600,label='70$\degree$')
plt.plot(lat[val_ar_f_of_inc_lat[140,:]==1],mgt_f_of_inc_lat[140,val_ar_f_of_inc_lat[140,:] ==1]/3600,label='70$\degree$')
#plt.plot(lat,mgt_f_of_inc_lat[170,:]/3600,label='85$\degree$')
plt.plot(lat[val_ar_f_of_inc_lat[170,:]==1],mgt_f_of_inc_lat[170,val_ar_f_of_inc_lat[170,:] ==1]/3600,label='85$\degree$')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Maximum Gap Time (hr)')
plt.legend(title='Inclination Angle',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.figure(6)
inc = np.linspace(0,180,361)
lat = np.linspace(0.0,90.0,181)
plt.plot(lat,ppd_f_of_inc_lat[20,:],label='10$\degree$')
plt.plot(lat,ppd_f_of_inc_lat[50,:],label='25$\degree$')
plt.plot(lat,ppd_f_of_inc_lat[80,:],label='40$\degree$')
plt.plot(lat,ppd_f_of_inc_lat[110,:],label='55$\degree$')
plt.plot(lat,ppd_f_of_inc_lat[140,:],label='70$\degree$')
plt.plot(lat,ppd_f_of_inc_lat[170,:],label='85$\degree$')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Passes Per Day')
plt.legend(title='Inclination Angle',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.figure(7)
inc = np.linspace(0,180,361)
lat = np.linspace(0.0,90.0,181)
plt.plot(lat,mpt_f_of_inc_lat[20,:]/60,label='10$\degree$')
plt.plot(lat,mpt_f_of_inc_lat[50,:]/60,label='25$\degree$')
plt.plot(lat,mpt_f_of_inc_lat[80,:]/60,label='40$\degree$')
plt.plot(lat,mpt_f_of_inc_lat[110,:]/60,label='55$\degree$')
plt.plot(lat,mpt_f_of_inc_lat[140,:]/60,label='70$\degree$')
plt.plot(lat,mpt_f_of_inc_lat[170,:]/60,label='85$\degree$')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Mean Pass Time (min)')
plt.legend(title='Inclination Angle',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.figure(8)
el = np.linspace(0,25,51)
lat = np.linspace(0.0,90.0,181)
plt.plot(lat,np.multiply(mpt_f_of_inc_lat[20,:], ppd_f_of_inc_lat[20,:])/60 ,label='10$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_inc_lat[50,:],ppd_f_of_inc_lat[50,:])/60,label='25$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_inc_lat[80,:],ppd_f_of_inc_lat[80,:])/60,label='40$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_inc_lat[110,:],ppd_f_of_inc_lat[110,:])/60,label='55$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_inc_lat[140,:],ppd_f_of_inc_lat[140,:])/60,label='70$\degree$')
plt.plot(lat,np.multiply(mpt_f_of_inc_lat[170,:],ppd_f_of_inc_lat[170,:])/60,label='85$\degree$')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Mean Daily Coverage Time (min)')
plt.legend(title='Inclination Angle',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.show()

plt.figure(9)
alt = np.linspace(200,2000,int((2000-200)/10+1))
lat = np.linspace(0.0,90.0,181)
#plt.plot(lat,mgt_f_of_alt_lat[0,:]/3600,label='200')
plt.plot(lat[val_ar_f_of_alt_lat[0,:]==1],mgt_f_of_alt_lat[0,val_ar_f_of_alt_lat[0,:] ==1]/3600,label='200')
#plt.plot(lat,mgt_f_of_alt_lat[30,:]/3600,label='500')
plt.plot(lat[val_ar_f_of_alt_lat[30,:]==1],mgt_f_of_alt_lat[30,val_ar_f_of_alt_lat[30,:] ==1]/3600,label='500')
#plt.plot(lat,mgt_f_of_alt_lat[60,:]/3600,label='800')
plt.plot(lat[val_ar_f_of_alt_lat[60,:]==1],mgt_f_of_alt_lat[60,val_ar_f_of_alt_lat[60,:] ==1]/3600,label='800')
#plt.plot(lat,mgt_f_of_alt_lat[90,:]/3600,label='1100')
plt.plot(lat[val_ar_f_of_alt_lat[90,:]==1],mgt_f_of_alt_lat[90,val_ar_f_of_alt_lat[90,:] ==1]/3600,label='1100')
#plt.plot(lat,mgt_f_of_alt_lat[120,:]/3600,label='1400')
plt.plot(lat[val_ar_f_of_alt_lat[120,:]==1],mgt_f_of_alt_lat[120,val_ar_f_of_alt_lat[120,:] ==1]/3600,label='1400')
#plt.plot(lat,mgt_f_of_alt_lat[150,:]/3600,label='1700')
plt.plot(lat[val_ar_f_of_alt_lat[150,:]==1],mgt_f_of_alt_lat[150,val_ar_f_of_alt_lat[150,:] ==1]/3600,label='1700')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Maximum Gap Time (hr)')
plt.legend(title='Altitude (km)',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.figure(10)
inc = np.linspace(0,180,361)
lat = np.linspace(0.0,90.0,181)
plt.plot(lat,ppd_f_of_alt_lat[0,:],label='200')
plt.plot(lat,ppd_f_of_alt_lat[30,:],label='500')
plt.plot(lat,ppd_f_of_alt_lat[60,:],label='800')
plt.plot(lat,ppd_f_of_alt_lat[90,:],label='1100')
plt.plot(lat,ppd_f_of_alt_lat[120,:],label='1400')
plt.plot(lat,ppd_f_of_alt_lat[150,:],label='1700')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Passes Per Day')
plt.legend(title='Altitude (km)',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.figure(11)
inc = np.linspace(0,180,361)
lat = np.linspace(0.0,90.0,181)
plt.plot(lat,mpt_f_of_alt_lat[0,:]/60,label='200')
plt.plot(lat,mpt_f_of_alt_lat[30,:]/60,label='500')
plt.plot(lat,mpt_f_of_alt_lat[60,:]/60,label='800')
plt.plot(lat,mpt_f_of_alt_lat[90,:]/60,label='1100')
plt.plot(lat,mpt_f_of_alt_lat[120,:]/60,label='1400')
plt.plot(lat,mpt_f_of_alt_lat[150,:]/60,label='1700')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Mean Pass Time (min)')
plt.legend(title='Altitude (km)',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.figure(12)
el = np.linspace(0,25,51)
lat = np.linspace(0.0,90.0,181)
plt.plot(lat,np.multiply(mpt_f_of_alt_lat[0,:], ppd_f_of_alt_lat[0,:])/60,label='200')
plt.plot(lat,np.multiply(mpt_f_of_alt_lat[30,:],ppd_f_of_alt_lat[30,:])/60,label='500')
plt.plot(lat,np.multiply(mpt_f_of_alt_lat[60,:],ppd_f_of_alt_lat[60,:])/60,label='800')
plt.plot(lat,np.multiply(mpt_f_of_alt_lat[90,:],ppd_f_of_alt_lat[90,:])/60,label='1100')
plt.plot(lat,np.multiply(mpt_f_of_alt_lat[120,:],ppd_f_of_alt_lat[120,:])/60,label='1400')
plt.plot(lat,np.multiply(mpt_f_of_alt_lat[150,:],ppd_f_of_alt_lat[150,:])/60,label='1700')
plt.xlabel('Latitude ($\degree$)')
plt.ylabel('Mean Daily Coverage Time (min)')
plt.legend(title='Altitude (km)',loc=4, bbox_to_anchor=(0., 1.025, 1., .102), ncol=6, mode="expand", borderaxespad=0.)
plt.tight_layout(rect=[-0.01, -0.01, 1.02, 0.92])
plt.grid()
plt.show()